'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2010
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'


Imports System
Imports System.Configuration
Imports System.Data
Imports DotNetNuke
Imports DotNetNuke.Common.Utilities

Namespace DotNetNuke.Modules.Roadmap

    Public Class EnhancementController

        Const CacheKey As String = "GetEnhancements"

        Public Function GetEnhancements(ByVal ModuleId As Integer, ByVal IsAdmin As Boolean, ByVal PageSize As Integer, ByVal PageIndex As Integer, ByVal Filter As Integer, ByRef TotalRecords As Integer) As ArrayList

            Dim arrLinks As ArrayList = Nothing

            Dim dr As IDataReader = DataProvider.Instance().GetEnhancements(ModuleId, IsAdmin, PageSize, PageIndex, Filter)
            Try
                While dr.Read
                    TotalRecords = Convert.ToInt32(dr("TotalRecords"))
                End While
                dr.NextResult()
                arrLinks = CBO.FillCollection(dr, GetType(EnhancementInfo))
            Finally
                If Not dr Is Nothing Then
                    dr.Close()
                End If
            End Try

            Return arrLinks

        End Function

        Public Function GetEnhancementsByUser(ByVal ModuleId As Integer, ByVal UserId As Integer) As ArrayList

            Return CBO.FillCollection(DataProvider.Instance().GetEnhancementsByUser(ModuleId, UserId), GetType(EnhancementInfo))

        End Function

        Public Function GetEnhancement(ByVal EnhancementID As Integer, ByVal ModuleID As Integer) As EnhancementInfo

            Return CType(CBO.FillObject(DataProvider.Instance().GetEnhancement(EnhancementID, ModuleID), GetType(EnhancementInfo)), EnhancementInfo)

        End Function

        Public Sub DeleteEnhancement(ByVal EnhancementID As Integer, ByVal ModuleID As Integer)

            DataProvider.Instance().DeleteEnhancement(EnhancementID, ModuleID)

        End Sub

        Public Function AddEnhancement(ByVal ModuleId As Integer, ByVal Title As String, ByVal URL As String, ByVal Description As String, ByVal Problem As String, ByVal Rationale As String, ByVal Solution As String, ByVal Impact As String, ByVal Risk As String, ByVal Authorized As Boolean, ByVal Scheduled As String, ByVal Delivered As String, ByVal UserId As Integer) As Integer

            Return CType(DataProvider.Instance().AddEnhancement(ModuleId, Title, URL, Description, Problem, Rationale, Solution, Impact, Risk, Authorized, Scheduled, Delivered, UserId), Integer)

        End Function

        Public Sub UpdateEnhancement(ByVal EnhancementID As Integer, ByVal ModuleID As Integer, ByVal Title As String, ByVal URL As String, ByVal Description As String, ByVal Problem As String, ByVal Rationale As String, ByVal Solution As String, ByVal Impact As String, ByVal Risk As String, ByVal Authorized As Boolean, ByVal Scheduled As String, ByVal Delivered As String)

            DataProvider.Instance().UpdateEnhancement(EnhancementID, ModuleID, Title, URL, Description, Problem, Rationale, Solution, Impact, Risk, Authorized, Scheduled, Delivered)

        End Sub

    End Class

End Namespace

