'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2007
' by DotNetNuke Corporation
'


Namespace DotNetNuke.Modules.Roadmap

    Public MustInherit Class DataProvider

#Region "Shared/Static Methods"

        ' singleton reference to the instantiated object 
        Private Shared objProvider As DataProvider = Nothing

        ' constructor
        Shared Sub New()
            CreateProvider()
        End Sub

        ' dynamically create provider
        Private Shared Sub CreateProvider()
            objProvider = CType(Framework.Reflection.CreateObject("data", "DotNetNuke.Modules.Roadmap", ""), DataProvider)
        End Sub

        ' return the provider
        Public Shared Shadows Function Instance() As DataProvider
            Return objProvider
        End Function

#End Region

#Region "Abstract methods"

        Public MustOverride Function GetEnhancements(ByVal ModuleId As Integer, ByVal IsAdmin As Boolean, ByVal PageSize As Integer, ByVal PageIndex As Integer, ByVal Filter As Integer) As IDataReader
        Public MustOverride Function GetEnhancementsByUser(ByVal ModuleId As Integer, ByVal UserId As Integer) As IDataReader
        Public MustOverride Function GetEnhancement(ByVal EnhancementId As Integer, ByVal ModuleId As Integer) As IDataReader
        Public MustOverride Sub DeleteEnhancement(ByVal EnhancementId As Integer, ByVal ModuleId As Integer)
        Public MustOverride Function AddEnhancement(ByVal ModuleId As Integer, ByVal Title As String, ByVal URL As String, ByVal Description As String, ByVal Problem As String, ByVal Rationale As String, ByVal Solution As String, ByVal Impact As String, ByVal Risk As String, ByVal Authorized As Boolean, ByVal Scheduled As String, ByVal Delivered As String, ByVal UserId As Integer) As Integer
        Public MustOverride Sub UpdateEnhancement(ByVal EnhancementId As Integer, ByVal ModuleId As Integer, ByVal Title As String, ByVal URL As String, ByVal Description As String, ByVal Problem As String, ByVal Rationale As String, ByVal Solution As String, ByVal Impact As String, ByVal Risk As String, ByVal Authorized As Boolean, ByVal Scheduled As String, ByVal Delivered As String)

        Public MustOverride Function GetEnhancementVote(ByVal EnhancementId As Integer, ByVal UserId As Integer) As IDataReader
        Public MustOverride Sub AddEnhancementVote(ByVal EnhancementId As Integer, ByVal UserId As Integer)

        Public MustOverride Function GetEnhancementComments(ByVal EnhancementId As Integer) As IDataReader
        Public MustOverride Function GetEnhancementComment(ByVal EnhancementCommentId As Integer, ByVal EnhancementId As Integer) As IDataReader
        Public MustOverride Sub DeleteEnhancementComment(ByVal EnhancementCommentId As Integer, ByVal EnhancementId As Integer)
        Public MustOverride Sub AddEnhancementComment(ByVal EnhancementId As Integer, ByVal Comment As String, ByVal UserId As Integer)
        Public MustOverride Sub UpdateEnhancementComment(ByVal EnhancementCommentId As Integer, ByVal EnhancementId As Integer, ByVal Comment As String)

#End Region

    End Class

End Namespace
