'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2010
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'


Imports DotNetNuke.Services.Localization
Imports DotNetNuke.Services.Exceptions

Namespace DotNetNuke.Modules.Roadmap

    Partial Public Class Settings
        Inherits Entities.Modules.ModuleSettingsBase

#Region "Base Method Implementations"

        Public Overrides Sub LoadSettings()
            Try
                If Not Page.IsPostBack Then
                    If CType(Settings("sendto"), String) <> "" Then
                        txtSendTo.Text = CType(Settings("sendto"), String)
                    End If
                    If CType(Settings("rows"), String) <> "" Then
                        txtRows.Text = CType(Settings("rows"), String)
                    Else
                        txtRows.Text = "10"
                    End If
                    If CType(Settings("roadmaptemplate"), String) <> "" Then
                        txtRoadmapTemplate.Text = CType(Settings("roadmaptemplate"), String)
                    Else
                        txtRoadmapTemplate.Text = Localization.GetString("RoadmapTemplate.Text", LocalResourceFile)
                    End If
                    If CType(Settings("detailstemplate"), String) <> "" Then
                        txtDetailsTemplate.Text = CType(Settings("detailstemplate"), String)
                    Else
                        txtDetailsTemplate.Text = Localization.GetString("DetailsTemplate.Text", LocalResourceFile)
                    End If
                    If CType(Settings("commentstemplate"), String) <> "" Then
                        txtCommentsTemplate.Text = CType(Settings("commentstemplate"), String)
                    Else
                        txtCommentsTemplate.Text = Localization.GetString("CommentsTemplate.Text", LocalResourceFile)
                    End If
                End If
            Catch exc As Exception
                ProcessModuleLoadException(Me, exc)
            End Try
        End Sub

        Public Overrides Sub UpdateSettings()
            Try
                Dim objModules As New Entities.Modules.ModuleController
                objModules.UpdateTabModuleSetting(TabModuleId, "sendto", txtSendTo.Text)
                objModules.UpdateTabModuleSetting(TabModuleId, "rows", txtRows.Text)
                objModules.UpdateTabModuleSetting(TabModuleId, "roadmaptemplate", txtRoadmapTemplate.Text)
                objModules.UpdateTabModuleSetting(TabModuleId, "detailstemplate", txtDetailsTemplate.Text)
                objModules.UpdateTabModuleSetting(TabModuleId, "commentstemplate", txtCommentsTemplate.Text)

            Catch exc As Exception           'Module failed to load
                ProcessModuleLoadException(Me, exc)
            End Try
        End Sub

#End Region

    End Class

End Namespace