'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2010
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports DotNetNuke
Imports System.Text
Imports System.Reflection
Imports DotNetNuke.Services.Localization
Imports DotNetNuke.Services.Exceptions

Namespace DotNetNuke.Modules.Roadmap

    Partial Public Class View

        Inherits Entities.Modules.PortalModuleBase

#Region "Private Members"

        Private RoadmapTemplate As String
        Private Filter As Integer = 0
        Private CurrentPage As Integer = 1
        Private TotalPages As Integer = 0

#End Region

        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            Try
                If CType(Settings("rows"), String) <> "" Then
                    If lblCurrentPage1.Text <> "" Then
                        CurrentPage = CType(lblCurrentPage1.Text, Integer)
                    End If
                    If lblTotalPages1.Text <> "" Then
                        TotalPages = CType(lblTotalPages1.Text, Integer)
                    End If
                End If

                If Not Request.QueryString("filter") Is Nothing Then
                    Filter = Integer.Parse(Request.QueryString("filter"))
                Else
                    If Not cboFilter.SelectedItem Is Nothing Then
                        Filter = Integer.Parse(cboFilter.SelectedItem.Value)
                    End If
                End If

                If Not Request.QueryString("page") Is Nothing Then
                    CurrentPage = Integer.Parse(Request.QueryString("page"))
                End If

                If CType(Settings("roadmaptemplate"), String) <> "" Then
                    RoadmapTemplate = CType(Settings("roadmaptemplate"), String)
                Else
                    RoadmapTemplate = Localization.GetString("RoadmapTemplate.Text", LocalResourceFile)
                End If

                If Not Page.IsPostBack Then

                    If IsEditable() Then
                        cboFilter.Items.Add(New ListItem("Unauthorized Enhancements", "-1"))
                    End If
                    cboFilter.Items.Add(New ListItem("Most Popular Enhancements", "0"))
                    cboFilter.Items.Add(New ListItem("Most Recent Enhancements", "1"))
                    cboFilter.Items.Add(New ListItem("Scheduled Enhancements", "2"))
                    cboFilter.Items.Add(New ListItem("Delivered Enhancements", "3"))
                    cboFilter.Items.FindByValue(Filter.ToString).Selected = True

                    If Request.IsAuthenticated Then
                        cmdAdd.Text = Localization.GetString("Add.Text", LocalResourceFile)
                    Else
                        cmdAdd.Text = Localization.GetString("Login.Text", LocalResourceFile)
                    End If

                    BindData()
                End If
            Catch exc As Exception
                ProcessModuleLoadException(Me, exc)
            End Try

        End Sub

        Protected Sub lstEnhancements_ItemDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataListItemEventArgs) Handles lstEnhancements.ItemDataBound
            Dim strEnhancement As String = RoadmapTemplate
            Dim strValue As String = ""

            ' add content to template
            Dim objProperties As ArrayList = Common.Utilities.CBO.GetPropertyInfo(GetType(EnhancementInfo))
            Dim intProperty As Integer
            Dim objPropertyInfo As PropertyInfo
            For intProperty = 0 To objProperties.Count - 1
                objPropertyInfo = CType(objProperties(intProperty), PropertyInfo)
                If strEnhancement.IndexOf("[" & objPropertyInfo.Name.ToUpper & "]") <> -1 Then
                    strValue = Server.HtmlDecode(DataBinder.Eval(e.Item.DataItem, objPropertyInfo.Name).ToString())
                    strEnhancement = strEnhancement.Replace("[" & objPropertyInfo.Name.ToUpper & "]", strValue)
                End If
            Next intProperty

            ' manage edit
            If IsEditable() = True Then
                Dim strEdit As String = ""
                strEdit += "<a href=""" & EditUrl("enhancementid", DataBinder.Eval(e.Item.DataItem, "EnhancementID").ToString()) & """>"
                strEdit += "<img title=""Edit Enhancement"" src=""" & Common.Globals.ApplicationPath & "/images/edit.gif"" alt=""Edit Enhancement"" style=""border-width:0px;"" />"
                strEdit += "</a>"
                strEnhancement = strEnhancement.Replace("[EDIT]", strEdit)
            Else
                strEnhancement = strEnhancement.Replace("[EDIT]", "")
            End If

            ' manage details
            Dim strDetails As String = ""
            strDetails += "<a href=""" & EditUrl("enhancementid", DataBinder.Eval(e.Item.DataItem, "EnhancementID").ToString(), "Details") & """>"
            strDetails += DataBinder.Eval(e.Item.DataItem, "Title").ToString()
            strDetails += "</a>"
            If DataBinder.Eval(e.Item.DataItem, "Scheduled").ToString() <> "" And DataBinder.Eval(e.Item.DataItem, "Delivered").ToString() = "" Then
                strDetails += " <span class=""NormalBold"">(Scheduled For " & DataBinder.Eval(e.Item.DataItem, "Scheduled").ToString() & ")</span>"
            End If
            If DataBinder.Eval(e.Item.DataItem, "Delivered").ToString() <> "" Then
                strDetails += " <span class=""NormalBold"">(Delivered In " & DataBinder.Eval(e.Item.DataItem, "Delivered").ToString() & ")</span>"
            End If
            strEnhancement = strEnhancement.Replace("[DETAILS]", strDetails)

            ' manage vote
            Dim strVoteURL As String = ""
            If Request.IsAuthenticated Then
                strVoteURL += "<a href=""" & ModulePath & "Vote.aspx?tabid=" & TabId.ToString & "&enhancementid=" & DataBinder.Eval(e.Item.DataItem, "EnhancementID").ToString() & "&page=" & lblCurrentPage1.Text & "&filter=" & Filter.ToString() & """>"
                strVoteURL += "<img title=""Vote For This Enhancement"" src=""" & ModulePath & "vote.gif"" alt=""Vote For This Enhancement"" style=""border-width:0px;"" />"
                strVoteURL += "</a>"
            Else
                strVoteURL += "<img title=""You Must Login To Vote"" src=""" & ModulePath & "vote.gif"" alt=""You Must Login To Vote"" style=""border-width:0px;"" />"
            End If
            strEnhancement = strEnhancement.Replace("[VOTE]", strVoteURL)

            ' manage image
            If DataBinder.Eval(e.Item.DataItem, "URL").ToString() <> "" Then
                strEnhancement = strEnhancement.Replace("[IMAGE]", "<br><img src=""" & DataBinder.Eval(e.Item.DataItem, "URL").ToString() & """ style=""border-width:0px;"" /><br>")
            Else
                strEnhancement = strEnhancement.Replace("[IMAGE]", "")
            End If

            ' manage authorization
            If IsEditable() = True Then
                If CType(DataBinder.Eval(e.Item.DataItem, "Authorized"), Boolean) = False Then
                    Dim strAuthorized As String = ""
                    strAuthorized += "<img title=""Not Authorized"" src=""" & ModulePath & "authorize.gif"" alt=""Not Authorized"" style=""border-width:0px;"" />"
                    strEnhancement = strEnhancement.Replace("[AUTHORIZE]", strAuthorized)
                Else
                    strEnhancement = strEnhancement.Replace("[AUTHORIZE]", "")
                End If
            Else
                strEnhancement = strEnhancement.Replace("[AUTHORIZE]", "")
            End If

            ' manage carriage returns
            strEnhancement = strEnhancement.Replace(vbCrLf, "<BR />")

            ' assign the content
            Dim lblEnhancement As Label = CType(e.Item.FindControl("lblEnhancement"), Label)
            lblEnhancement.Text = strEnhancement
        End Sub


        Private Sub BindData()

            lstEnhancements.RepeatColumns = 1
            lstEnhancements.RepeatDirection = RepeatDirection.Vertical

            Dim intRows As Integer = 10
            If CType(Settings("rows"), String) <> "" Then
                intRows = CType(Settings("rows"), Integer)
            End If

            Dim PageSize As Integer = intRows
            Dim TotalRecords As Integer

            lblCurrentPage1.Text = CurrentPage.ToString
            lblCurrentPage2.Text = CurrentPage.ToString

            Dim objEnhancements As New EnhancementController
            Dim arrEnhancements As ArrayList = objEnhancements.GetEnhancements(ModuleId, IsEditable, PageSize, CurrentPage - 1, Filter, TotalRecords)
            lstEnhancements.DataSource = arrEnhancements
            lstEnhancements.DataBind()

            TotalPages = CType(System.Math.Ceiling(TotalRecords / PageSize), Integer)
            If TotalPages = 0 Then
                TotalPages = 1
            End If
            lblTotalPages1.Text = TotalPages.ToString
            lblTotalPages2.Text = TotalPages.ToString

            If TotalPages = 1 Then
                tabPaging1.Visible = False
                tabPaging2.Visible = False
            Else
                tabPaging1.Visible = True
                tabPaging2.Visible = True
            End If

        End Sub

        Protected Sub cboFilter_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cboFilter.SelectedIndexChanged
            CurrentPage = 1
            Filter = Integer.Parse(cboFilter.SelectedItem.Value)
            BindData()
        End Sub

        Private Sub cmdFirst_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdFirst1.Click, cmdFirst1.Click
            CurrentPage = 1
            BindData()
        End Sub

        Private Sub cmdPrevious_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdPrevious1.Click, cmdPrevious2.Click
            If CurrentPage > 1 Then
                CurrentPage -= 1
                BindData()
            End If
        End Sub

        Private Sub cmdNext_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdNext1.Click, cmdNext2.Click
            If CurrentPage < TotalPages Then
                CurrentPage += 1
                BindData()
            End If
        End Sub

        Private Sub cmdLast_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdLast1.Click, cmdLast2.Click
            CurrentPage = TotalPages
            BindData()
        End Sub

        Protected Sub cmdAdd_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdAdd.Click
            If Request.IsAuthenticated Then
                Response.Redirect(EditUrl())
            Else
                Response.Redirect(Request.RawUrl)
            End If
        End Sub

    End Class

End Namespace

