'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2010
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'


Imports DotNetNuke.Entities.Users
Imports DotNetNuke.Services.Exceptions
Imports DotNetNuke.Common.Globals

Namespace DotNetNuke.Modules.Roadmap

    Partial Public Class Vote

        Inherits System.Web.UI.Page

        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            Try
                Dim EnhancementID As Integer = -1
                If Not Request.QueryString("enhancementid") Is Nothing Then
                    EnhancementID = Integer.Parse(Request.QueryString("enhancementid"))
                End If

                Dim Page As Integer = -1
                If Not Request.QueryString("page") Is Nothing Then
                    Page = Integer.Parse(Request.QueryString("page"))
                End If

                Dim Filter As Integer = 0
                If Not Request.QueryString("filter") Is Nothing Then
                    Filter = Integer.Parse(Request.QueryString("filter"))
                End If

                Dim UserID As Integer = -1
                If Request.IsAuthenticated Then
                    Dim objUserInfo As UserInfo = UserController.GetCurrentUserInfo
                    If Not objUserInfo Is Nothing Then
                        UserID = objUserInfo.UserID
                    End If
                End If

                If EnhancementID <> -1 And UserID <> -1 Then

                    Dim objEnhancementVotes As New EnhancementVoteController
                    Dim objEnhancementVote As EnhancementVoteInfo = objEnhancementVotes.GetEnhancementVote(EnhancementID, UserID)
                    If objEnhancementVote Is Nothing Then
                        objEnhancementVotes.AddEnhancementVote(EnhancementID, UserID)
                    End If

                End If

                Response.Redirect(NavigateURL(Integer.Parse(Request.QueryString("tabid")), "", "page=" & Page.ToString, "filter=" & Filter.ToString), True)

            Catch exc As Exception
                ProcessPageLoadException(exc)
            End Try
        End Sub

    End Class

End Namespace

